// SortTreeCtrl.h : header file
// Copyright (c) 2016 by David Wincelberg
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CTreeCtrlData;
class CTreeCtrlOrder;
class CStringOrder;

/////////////////////////////////////////////////////////////////////////////
// CSortTreeCtrl window

class CSortTreeCtrl : public CTreeCtrl
{
// Construction/Destruction
public:
	CSortTreeCtrl (CTreeCtrlOrder* pTreeCtrlOrder = nullptr, bool bHandleDelete = true);
	CSortTreeCtrl (CStringOrder* pStringOrder, bool bHandleDeleteInner = true,
		bool bHandleDeleteOuter = true);
	virtual ~CSortTreeCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSortTreeCtrl)
	//}}AFX_VIRTUAL

// Attributes
private:
	CTreeCtrlOrder* m_pTreeCtrlOrder;
	bool m_bHandleDelete;
	bool m_bAllowOrderMod;

// Operations
public:
	void SetSortOrder (CTreeCtrlOrder* pTreeCtrlOrder, bool bHandleDelete = true);
	void SetStringOrder (CStringOrder* pStringOrder, bool bHandleDelete = true);
	HTREEITEM InsertItem (LPCTSTR lpszItem, HTREEITEM hParent = TVI_ROOT,
		HTREEITEM hInsertAfter = TVI_LAST, CTreeCtrlData* pTreeCtrlData = nullptr);
	HTREEITEM InsertItem (LPCTSTR lpszItem, int nImage, int nSelectedImage,
		HTREEITEM hParent = TVI_ROOT, HTREEITEM hInsertAfter = TVI_LAST,
		CTreeCtrlData* pTreeCtrlData = nullptr);
	HTREEITEM InsertItem (UINT nMask, LPCTSTR lpszItem, int nImage,
		int nSelectedImage, UINT nState, UINT nStateMask, LPARAM lParam,
		HTREEITEM hParent = TVI_ROOT, HTREEITEM hInsertAfter = TVI_LAST,
		CTreeCtrlData* pTreeCtrlData = nullptr);
	HTREEITEM InsertItem (LPTVINSERTSTRUCT lpInsertStruct,
		CTreeCtrlData* pTreeCtrlData = nullptr);
	BOOL  DeleteItem (HTREEITEM hItem);
	BOOL  SortChildren (HTREEITEM hItem);
	BOOL  DeleteAllItems();
	BOOL  SetItemData (HTREEITEM hItem, DWORD dwData);
	DWORD GetItemData (HTREEITEM hItem) const;
	BOOL  SetItemDataObjPtr (HTREEITEM hItem, CTreeCtrlData* pTreeCtrlData);
	CTreeCtrlData* GetItemDataObjPtr (HTREEITEM hItem) const;

private:
	bool CheckTreeCtrlData (CTreeCtrlData** ppTreeCtrlData, LPCTSTR lpszItem,
		LPARAM lParam = 0);
	static int CALLBACK CompareFunc (LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSortTreeCtrl)
	afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeleteItem(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
