// StringOrder.cpp: implementation of the CStringOrder class.
// Copyright (c) 2017 by David Wincelberg
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "StringOrder.h"

#include <cstring>		// for _stricmp

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStringOrder::CStringOrder (bool bLimit /* = false */) : m_bLimit (bLimit)
{

}


CStringOrder::~CStringOrder()
{

}

//////////////////////////////////////////////////////////////////////
// Operations
//////////////////////////////////////////////////////////////////////

// Action:	Alphabetic comparisons.
int CStringOrder::CompareStrings (LPCTSTR pszItem1, LPCTSTR pszItem2) const
{
	if (pszItem1 == nullptr || pszItem2 == nullptr)
		return 0;

	int nTest = ::_tcsicmp (pszItem1, pszItem2);	// generic for _stricmp
	return (m_bLimit ? LimitResult (nTest) : nTest);
}	// CompareStrings


// Action:	Limits comparison results to -1, 0 or +1 since
//			some comparison functions may expect these values.
int CStringOrder::LimitResult (int nTest) const
{
	if (nTest == 0)
		return 0;
	else if (nTest > 0)
		return +1;
	else
		return -1;
}	// LimitResult
