// TreeCtrlData.cpp: implementation of the TreeCtrlData class.
// Copyright (c) 2016 by David Wincelberg
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TreeCtrlData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTreeCtrlData::CTreeCtrlData (LPCTSTR pText /* = nullptr */, LPARAM lParam /* = 0 */)
{
	SetText (pText);
	SetLParam (lParam);
}	// CTreeCtrlData


CTreeCtrlData::~CTreeCtrlData()
{

}

//////////////////////////////////////////////////////////////////////
// Operations
//////////////////////////////////////////////////////////////////////

// Action:	Sets the string.
void CTreeCtrlData::SetText (LPCTSTR pText)
{
	if (pText != nullptr)
		m_strText = pText;
}	// SetText


// Action:	Retrieves the string.
// Note:	This virtual function may be replaced or supplemented as needed.
CString CTreeCtrlData::GetText() const {
	return m_strText;
}


// Action:	Copies the data members from another object.
CTreeCtrlData& CTreeCtrlData::operator= (const CTreeCtrlData& other)
{
	if (&other != this) {
		m_strText = other.m_strText;
		m_lParam  = other.m_lParam;
	}

	return *this;
}	// operator=
